=== modified file 'NEWS'
--- NEWS	2009-07-09 19:58:59 +0000
+++ NEWS	2009-08-12 17:53:03 +0000
@@ -1,3 +1,12 @@
+0.97.0 UNRELEASED
+
+BUG FIXES
+
+  * Avoid GnomeKeyringCredentialStore traceback on Ubuntu Hardy
+    by being more tolerant about gobject methods availability.
+    (Vincent Ladeuil, #403430)
+
+
 0.96.2	2009-07-08
 
  BUG FIXES

=== modified file 'keyring.py'
--- keyring.py	2009-06-04 21:10:21 +0000
+++ keyring.py	2009-08-12 17:53:03 +0000
@@ -29,9 +29,13 @@
 
     def __init__(self):
         CredentialStore.__init__(self)
-        # External apps that load bzrlib may also set this, so 
-        # don't override:
-        if gobject.get_application_name() is None:
+        # Older versions of gobject don't provide get_application_name so we
+        # can't always check.
+        get_app_name = getattr(gobject, 'get_application_name', None)
+        if get_app_name is None or get_app_name() is None:
+            # External applications that load bzrlib may already have set the
+            # application name so we don't contradict them (when we can
+            # determine it that is).
             gobject.set_application_name("bzr")
 
     def decode_password(self, credentials):

